include files.e
include tokens.e
include tree.e
include get.e
include sort.e
global integer do_includes
sequence included, GLOBAL_LEVEL, FILE_LEVEL, RTN_LEVEL, BLK_LEVEL
GLOBAL_LEVEL = {}
FILE_LEVEL = {}
RTN_LEVEL = {}
BLK_LEVEL = {}
do_includes = 1
type alpha(integer x)
    return (x >= 'a' and x <= 'z') or (x >= 'A' and x <= 'Z')
end type
type digit(integer x)
    return (x >= '0' and x <= '9')
end type
constant EU_KEYWORDS = {
    "if", "end", "then", "procedure", "else", "for", "return",
    "do", "elsif", "while", "type", "constant", "to", "and", "or",
    "exit", "function", "global", "by", "not", "include",
    "with", "without", "xor"}
global type euid(sequence s)
    if find(s,EU_KEYWORDS) then
	return 0
    end if
    if length(s) then
	if alpha(s[1]) then
	    for i = 2 to length(s) do
		if (not alpha(s[i])) and (not digit(s[i])) and s[i] != '_' then
		    return 0
		end if
	    end for
	    return 1
	end if
    end if
    return 0
end type
global constant INCLUDE_FILE = 1,
		GLOBAL = 2,
		VARIABLE = 3,
		WITH = 4,
		CONSTANT = 5,
		FUNCTION = 6,
		PROCEDURE = 7,
		TYPE = 8,
		ASSIGN = 9,
		EXPR = 10,
		ADD = 11,
		SUB = 12,
		MUL = 13,
		DIV = 14,
		AND = 15,
		OR = 16,
		XOR = 17,
		NOT = 18,
		CALL = 19,
		VARREF = 20,
		ATOM = 21,
		SEQ = 22,
		NEG = 23,
		LT = 24,
		GT = 25,
		LE = 26,
		GE = 27,
		EQU = 28,
		NEQU = 29,
		CONCAT = 30,
		SUBSCRIPT = 31,
		WHILE = 32,
		FOR = 33,
		IF = 34,
		ELSIF = 35,
		ELSE = 36,
		REFADD = 37,
		REFSUB = 38,
		REFMUL = 39,
		REFDIV = 40,
		REFCONCAT = 41,
		EXIT = 42,
		RETURN = 43,
		STRING = 44,
		DEBUG = 45,
		WITHOUT = 46
function find_end(sequence typ, sequence tokens, integer token)
    integer depth
    depth = 1
    while token < length(tokens) do
	if equal(tokens[token][1],"end") then
	    token += 1
	    if equal(tokens[token][1],typ) then
		depth -= 1
		token += 1
		if depth = 0 then
		    return token
		end if
	    end if
	elsif equal(tokens[token][1],typ) then
	    depth += 1
	    token += 1
	else
	    token += 1
	end if
    end while
    return 0
end function
procedure parse1(tree_node node, sequence tokens, sequence applicable)
    integer token, t
    token = 1
    while token <= length(tokens) do
	t = 0
	for i = 1 to length(applicable) do
	    t = call_func(applicable[i],{node,tokens,token})
	    if t then
		exit
	    end if
	end for
	if not t then
	    puts(2, "Parse error!\n")
	    puts(2, "Unrecognized: " & tokens[token][1] & "\n")
	    printf(2,"%s @ %d:%d\n",tokens[token])
	    abort(1)
	end if
	if t = token then
	    puts(2,"whoops!\n")
	    abort(2)
	end if
	token = t
    end while
end procedure
function do_exit(tree_node node, sequence tokens, integer token)
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"exit") then
	n = alloc_node(node)
	node_set(n,{EXIT})
	return token+1
    end if
    return 0
end function
function do_include(tree_node node, sequence tokens, integer token)
    tree_node n
    object t
    if token < length(tokens) then
	if equal(tokens[token][1],"include") then
	    t = includeName(tokens[token+1][1])
	    if do_includes and not find(t,included) then
		n = alloc_node(node)
		node_set(n,{INCLUDE_FILE,t})
		included = append(included,t)
		t = tokenize(t)
		if integer(t) then
		    puts(2,"Can't load.\n")
		    abort(1)
		end if
		parse1(n,t,FILE_LEVEL)
	    end if
	    return token+2
	end if
    end if
    return 0
end function
function do_comment(tree_node node, sequence tokens, integer token)
    if token > length(tokens) then
	return 0
    end if
    if length(tokens[token][1]) >= 2 then
	if equal(tokens[token][1][1..2],"--") then
	    return token+1
	end if
    end if
    return 0
end function
function do_global(tree_node node, sequence tokens, integer token)
    tree_node n
    integer t
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"global") then
	n = alloc_node(node)
	node_set(n,{GLOBAL})
	for i = 1 to length(GLOBAL_LEVEL) do
	    t = call_func(GLOBAL_LEVEL[i],{n,tokens,token+1})
	    if t then
		exit
	    end if
	end for
	if t then
	    return t
	else
	    puts(2,"Parse error: expected declaration after global.\n")
	    printf(2,"%s @ %d:%d\n",tokens[token])
	    abort(1)
	end if
    end if
    return 0
end function
function do_variable(tree_node node, sequence tokens, integer token)
    sequence typ, names
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    typ = tokens[token][1]
    if not euid(typ) then
	return 0
    end if
    names = {}
    token += 1
    while token <= length(tokens) do
	names = append(names,tokens[token][1])
	if not euid(tokens[token][1]) then
	    return 0
	end if
	token += 1
	if token < length(tokens) then
	    if compare(tokens[token][1],",") then
		exit
	    end if
	    token += 1
	end if
    end while
    if length(names) then
	for i = 1 to length(names) do
	    n = alloc_node(node)
	    node_set(n,{VARIABLE,{typ,names[i]}})
	end for
	return token
    else
	return 0
    end if
end function
function do_routine(tree_node node, sequence tokens, integer token)
    sequence typ
    integer e
    tree_node n
    sequence name, arg_names, arg_types
    if token > length(tokens) then
	return 0
    end if
    typ = tokens[token][1]
    if find(typ,{"procedure","function","type"}) then
	token += 1
	if token > length(tokens) then
	    return 0
	end if
	name = tokens[token][1]
	arg_names = {}
	arg_types = {}
	token += 1
	if token > length(tokens) then
	    return 0
	end if
	if compare(tokens[token][1],"(") then
	    return 0
	end if
	token += 1
	if token > length(tokens) then
	    return 0
	end if
	if compare(tokens[token][1],")") then
	    while 1 do
		if token > length(tokens) then
		    return 0
		end if
		if not euid(tokens[token][1]) then
		    return 0
		end if
		arg_types = append(arg_types,tokens[token][1])
		token += 1
		if token > length(tokens) then
		    return 0
		end if
		if not euid(tokens[token][1]) then
		    return 0
		end if
		arg_names = append(arg_names,tokens[token][1])
		token += 1
		if token > length(tokens) then
		    return 0
		end if
		if equal(tokens[token][1],")") then
		    token += 1
		    exit
		elsif equal(tokens[token][1],",") then
		    token += 1
		else
		    return 0
		end if
	    end while
	else
	    token += 1
	end if
	e = find_end(typ,tokens,token+1)
	if e then
	    n = alloc_node(node)
	    if equal(typ,"procedure") then
		node_set(n,{PROCEDURE,name,arg_names})
	    elsif equal(typ,"function") then
		node_set(n,{FUNCTION,name,arg_names})
	    else
		node_set(n,{TYPE,name,arg_names})
	    end if
	    parse1(n,tokens[token..e-3],RTN_LEVEL)
	end if
	return e
    end if
    return 0
end function
integer p_do_expr
function do_csexpr(tree_node node, sequence tokens, integer token)
    integer x
    while token <= length(tokens) do
	x = call_func(p_do_expr,{node,tokens,token})
	if x then
	    token = x
	    if token > length(tokens) then
		exit
	    else
		if compare(tokens[token][1],",") then
		    exit
		else
		    token += 1
		end if
	    end if
	else
	    exit
	end if
    end while
    return token
end function
function do_subscript(tree_node node, sequence tokens, integer token)
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    if compare(tokens[token][1],"[") then
	return 0
    end if
    token += 1
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{SUBSCRIPT})
    token = call_func(p_do_expr,{n,tokens,token})
    if token = 0 or token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"]") then
	return token+1
    elsif equal(tokens[token][1],"..") then
	token = call_func(p_do_expr,{n,tokens,token+1})
	if token = 0 or token > length(tokens) then
	    return 0
	end if
	if compare(tokens[token][1],"]") then
	    return 0
	end if
	return token+1
    else
	return 0
    end if
end function
function do_call(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    if token > length(tokens) then
	return 0
    end if
    if not euid(tokens[token][1]) then
	return 0
    end if
    x = tokens[token][1]
    token += 1
    if token >= length(tokens) then
	return 0
    end if
    if compare(tokens[token][1],"(") then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{CALL,x})
    token += 1
    if equal(tokens[token][1],")") then
	return token + 1
    else
	token = do_csexpr(n,tokens,token)
	if not token then
	    free_node(n)
	    return 0
	else
	    if token > length(tokens) or compare(tokens[token][1],")") then
		free_node(n)
		return 0
	    else
		return token + 1
	    end if
	end if
    end if
end function
sequence namedrefs
namedrefs = {}
function do_nameref(tree_node node, sequence tokens, integer token, integer w)
    integer t
    for i = 1 to length(namedrefs) do
	if (namedrefs[i][2] and w) or (not w) then
	    t = call_func(namedrefs[i][1],{node,tokens,token})
	    if t then
		return t
	    end if
	end if
    end for
    return 0
end function
function cmp_pri(sequence a, sequence b)
    return compare(a[3],b[3])
end function
global procedure add_namedref(integer id, integer writable, atom priority)
    namedrefs = custom_sort(routine_id("cmp_pri"),
		append(namedrefs,{id,writable,priority}))
end procedure
function do_subscripts(tree_node node, sequence tokens, integer token)
    integer x
    while 1 do
	x = do_subscript(node,tokens,token)
	if x then
	    token = x
	else
	    return token
	end if
    end while
end function
function do_varref(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence name
    if token > length(tokens) or not euid(tokens[token][1]) then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{VARREF,tokens[token][1]})
    return do_subscripts(n,tokens,token+1)
end function
add_namedref(routine_id("do_call"),0,1)
add_namedref(routine_id("do_varref"),1,2)
function do_primitive(tree_node node, sequence tokens, integer token)
    object x
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"{") then
	n = alloc_node(node)
	node_set(n,{SEQ})
	token = do_csexpr(n,tokens,token+1)
	if token then
	    if token > length(tokens) or compare(tokens[token][1],"}") then
		free_node(n)
		return 0
	    end if
	    return token+1
	else
	    free_node(n)
	    return 0
	end if
    end if
    if equal(tokens[token][1],"(") then
	n = alloc_node(node)
	node_set(n,{EXPR})
	token = call_func(p_do_expr,{n,tokens,token+1})
	if token then
	    if token > length(tokens) or compare(tokens[token][1],")") then
		free_node(n)
		return 0
	    end if
	    return token+1
	else
	    free_node(n)
	    return 0
	end if
    end if
    x = do_nameref(node,tokens,token,0)
    if x then
	return x
    end if
    x = value(tokens[token][1])
    if x[1] = GET_SUCCESS then
	if atom(x[2]) then
	    n = alloc_node(node)
	    node_set(n,{ATOM,x[2]})
	    return token+1
	else
	    n = alloc_node(node)
	    node_set(n,{STRING,x[2]})
	    return token+1
	end if
    end if
    return 0
end function
function do_unary(tree_node node, sequence tokens, integer token)
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"-") then
	n = alloc_node(node)
	node_set(n,{NEG})
	token = do_primitive(n,tokens,token+1)
	if token then
	    return token
	else
	    free_node(n)
	    return 0
	end if
    elsif equal(tokens[token][1],"not") then
	n = alloc_node(node)
	node_set(n,{NOT})
	token = do_primitive(n,tokens,token+1)
	if token then
	    return token
	else
	    free_node(n)
	    return 0
	end if
    elsif equal(tokens[token][1],"+") then
	return do_primitive(node,tokens,token+1)
    else
	return do_primitive(node,tokens,token)
    end if
end function
function do_mul(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_unary(n,tokens,token)
    if token then
	if token < length(tokens) then
	    if equal(tokens[token][1],"*") then
		node_set(n,{MUL})
		token += 1
		token = do_mul(n,tokens,token)
		if token then
		    return token
		end if
	    elsif equal(tokens[token][1],"/") then
		node_set(n,{DIV})
		token += 1
		token = do_mul(n,tokens,token)
		if token then
		    return token
		end if
	    end if
	end if
	x = node_children(n)
	own_node(node,x[1])
	free_node(n)
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_add(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_mul(n,tokens,token)
    if token then
	if token < length(tokens) then
	    if equal(tokens[token][1],"+") then
		node_set(n,{ADD})
		token += 1
		token = do_add(n,tokens,token)
		if token then
		    return token
		end if
	    elsif equal(tokens[token][1],"-") then
		node_set(n,{SUB})
		token += 1
		token = do_add(n,tokens,token)
		if token then
		    return token
		end if
	    end if
	end if
	x = node_children(n)
	own_node(node,x[1])
	free_node(n)
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_concat(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_add(n,tokens,token)
    if token then
	if token < length(tokens) then
	    if equal(tokens[token][1],"&") then
		node_set(n,{CONCAT})
		token += 1
		token = do_concat(n,tokens,token)
		if token then
		    return token
		end if
	    end if
	end if
	x = node_children(n)
	own_node(node,x[1])
	free_node(n)
	return token
    else
	free_node(n)
	return 0
    end if
end function
constant CMP_OPS = {"<",">","<=",">=","=","!="}
constant CMP_IDS = {LT,GT,LE,GE,EQU,NEQU}
function do_cmp(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    integer i
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_concat(n,tokens,token)
    if token then
	if token < length(tokens) then
	    i = find(tokens[token][1],CMP_OPS)
	    if i then
		node_set(n,{CMP_IDS[i]})
		token += 1
		token = do_cmp(n,tokens,token)
		if token then
		    return token
		end if
	    end if
	end if
	x = node_children(n)
	own_node(node,x[1])
	free_node(n)
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_and(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence x
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_cmp(n,tokens,token)
    if token then
	if token < length(tokens) then
	    if equal(tokens[token][1],"and") then
		node_set(n,{AND})
		token += 1
		token = do_and(n,tokens,token)
		if token then
		    return token
		end if
	    elsif equal(tokens[token][1],"or") then
		node_set(n,{OR})
		token += 1
		token = do_and(n,tokens,token)
		if token then
		    return token
		end if
	    elsif equal(tokens[token][1],"xor") then
		node_set(n,{XOR})
		token += 1
		token = do_and(n,tokens,token)
		if token then
		    return token
		end if
	    end if
	end if
	x = node_children(n)
	own_node(node,x[1])
	free_node(n)
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_expr(tree_node node, sequence tokens, integer token)
    integer t
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{EXPR})
    t = do_and(n,tokens,token)
    if t then
	return t
    end if
    free_node(n)
    return 0
end function
function do_if(tree_node node, sequence tokens, integer token)
    tree_node n, n2, prev_n
    integer x, tr, t
    sequence tok
    if token > length(tokens) then
	return 0
    end if
    if compare(tokens[token][1],"if") then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{IF})
    x = do_expr(n,tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    token = x
    if token >= length(tokens) then
	free_node(n)
	return 0
    end if
    if compare(tokens[token][1],"then") then
	free_node(n)
	return 0
    end if
    token += 1
    x = 1
    tok = {}
    prev_n = n
    tr = 0
    while 1 do
	if token > length(tokens) then
	    free_node(n)
	    return 0
	end if
	if equal(tokens[token][1],"if") then
	    x += 1
	    tok = append(tok,tokens[token])
	    token += 1
	elsif equal(tokens[token][1],"end") then
	    token += 1
	    if token > length(tokens) then
		free_node(n)
		return 0
	    end if
	    if equal(tokens[token][1],"if") then
		x -= 1
		if x = 0 then
		    parse1(prev_n,tok,BLK_LEVEL)
		    token += 1
		    exit
		end if
	    end if
	    tok = append(tok,tokens[token-1])
	    tok = append(tok,tokens[token])
	    token += 1
	elsif equal(tokens[token][1],"elsif") and x = 1 then
	    tr = 1
	    n2 = alloc_node(n)
	    node_set(n2,{ELSIF})
	    parse1(prev_n,tok,BLK_LEVEL)
	    tok = {}
	    t = do_expr(n2,tokens,token+1)
	    prev_n = n2
	    if not t then
		free_node(n)
		return 0
	    end if
	    token = t
	    if token >= length(tokens) then
		free_node(n)
		return 0
	    end if
	    if compare(tokens[token][1],"then") then
		free_node(n)
		return 0
	    end if
	    token += 1
	elsif equal(tokens[token][1],"else") and x = 1 then
	    n2 = alloc_node(n)
	    node_set(n2,{ELSE})
	    parse1(prev_n,tok,BLK_LEVEL)
	    tok = {}
	    token += 1
	    prev_n = n2
	else
	    tok = append(tok,tokens[token])
	    token += 1
	end if
    end while
    return token
end function
function do_while(tree_node node, sequence tokens, integer token)
    tree_node n
    integer x
    if token > length(tokens) then
	return 0
    end if
    if compare(tokens[token][1],"while") then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{WHILE})
    x = do_expr(n,tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    token = x
    if token >= length(tokens) then
	free_node(n)
	return 0
    end if
    if compare(tokens[token][1],"do") then
	free_node(n)
	return 0
    end if
    x = find_end("while",tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    parse1(n,tokens[token+1..x-3],BLK_LEVEL)
    return x
end function
function inFunction(tree_node node)
    object x
    while node do
	x = node_data(node)
	if sequence(x) then
	    if x[1] = FUNCTION or x[1] = TYPE then
		return FUNCTION
	    elsif x[1] = PROCEDURE then
		return PROCEDURE
	    end if
	end if
	node = parent_node(node)
    end while
    return 0
end function
function do_return(tree_node node, sequence tokens, integer token)
    tree_node n
    integer x
    if compare(tokens[token][1],"return") then
	return 0
    end if
    n = alloc_node(node)
    x = inFunction(node)
    if x = 0 then
	free_node(n)
	return 0
    elsif x = PROCEDURE then
	node_set(n,{RETURN})
	return token+1
    else
	token = do_expr(n,tokens,token+1)
	if token then
	    node_set(n,{RETURN})
	    return token
	else
	    free_node(n)
	    return 0
	end if
    end if
end function
function do_for(tree_node node, sequence tokens, integer token)
    tree_node n
    integer x
    if token > length(tokens) then
	return 0
    end if
    if compare(tokens[token][1],"for") then
	return 0
    end if
    token += 1
    if token > length(tokens) or not euid(tokens[token][1]) then
	return 0
    end if
    n = alloc_node(node)
    node_set(n,{FOR, tokens[token][1]})
    token += 1
    if token > length(tokens) or compare(tokens[token][1],"=") then
	free_node(n)
	return 0
    end if
    x = do_expr(n,tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    token = x
    if token > length(tokens) or compare(tokens[token][1],"to") then
	free_node(n)
	return 0
    end if
    x = do_expr(n,tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    token = x
    if token > length(tokens) then
	free_node(n)
	return 0
    end if
    if equal(tokens[token][1],"by") then
	x = do_expr(n,tokens,token+1)
	if not x then
	    free_node(n)
	    return 0
	end if
	token = x
	if token > length(tokens) then
	    free_node(n)
	    return 0
	end if
    else
	x = alloc_node(n)
	node_set(x,{ATOM,1})
    end if
    if token >= length(tokens) then
	free_node(n)
	return 0
    end if
    if compare(tokens[token][1],"do") then
	free_node(n)
	return 0
    end if
    x = find_end("for",tokens,token+1)
    if not x then
	free_node(n)
	return 0
    end if
    parse1(n,tokens[token+1..x-3],BLK_LEVEL)
    return x
end function
constant REF_OPS = {"+","-","*","/","&"}
constant REF_IDS = {REFADD,REFSUB,REFMUL,REFDIV,REFCONCAT}
function do_refop(tree_node node, sequence tokens, integer token)
    tree_node n
    integer i
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_nameref(n,tokens,token,1)
    if not token then
	free_node(n)
	return 0
    end if
    i = find(tokens[token][1],REF_OPS)
    if not i then
	free_node(n)
	return 0
    end if
    token += 1
    if token > length(tokens) or compare(tokens[token][1],"=") then
	free_node(n)
	return 0
    end if
    token += 1
    if token > length(tokens) then
	free_node(n)
	return 0
    end if
    node_set(n,{REF_IDS[i]})
    token = do_expr(n,tokens,token)
    if token then
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_assign(tree_node node, sequence tokens, integer token)
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    n = alloc_node(node)
    token = do_nameref(n,tokens,token,1)
    if not token then
	free_node(n)
	return 0
    end if
    if compare(tokens[token][1],"=") then
	free_node(n)
	return 0
    end if
    token += 1
    if token > length(tokens) then
	free_node(n)
	return 0
    end if
    node_set(n,{ASSIGN})
    token = do_expr(n,tokens,token)
    if token then
	return token
    else
	free_node(n)
	return 0
    end if
end function
function do_constant(tree_node node, sequence tokens, integer token)
    tree_node n
    sequence s
    integer found, t
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"constant") then
	found = 0
	token += 1
	while 1 do
	    if token >= length(tokens) then
		return 0
	    end if
	    if not euid(tokens[token][1]) then
		return 0
	    end if
	    s = tokens[token][1]
	    token += 1
	    if compare(tokens[token][1],"=") then
		return 0
	    end if
	    n = alloc_node(node)
	    token = do_expr(n,tokens,token+1)
	    if not token then
		free_node(n)
		return 0
	    end if
	    node_set(n,{CONSTANT,s})
	    found = 1
	    if token <= length(tokens) then
		if compare(tokens[token][1],",") then
		    exit
		end if
	    end if
	    token += 1
	end while
	if found then
	    return token
	end if
    end if
    return 0
end function
function do_with(tree_node node, sequence tokens, integer token)
    tree_node n
    if token < length(tokens) then
	if equal(tokens[token][1],"with") then
	    n = alloc_node(node)
	    token += 1
	    node_set(n,{WITH,tokens[token][1]})
	    return token+1
	elsif equal(tokens[token][1],"without") then
	    n = alloc_node(node)
	    token += 1
	    node_set(n,{WITHOUT,tokens[token][1]})
	    return token+1
	end if
    end if
    return 0
end function
function do_debug(tree_node node, sequence tokens, integer token)
    tree_node n
    if token > length(tokens) then
	return 0
    end if
    if equal(tokens[token][1],"?") then
	n = alloc_node(node)
	node_set(n,{DEBUG})
	token = do_expr(n,tokens,token+1)
	if token then
	    return token
	else
	    free_node(n)
	end if
    end if
    return 0
end function
p_do_expr = routine_id("do_expr")
global procedure add_syntax(integer id, integer globalLevel,
    integer fileLevel, integer routineLevel, integer blockLevel)
    if globalLevel then
	GLOBAL_LEVEL &= id
    end if
    if fileLevel then
	FILE_LEVEL &= id
    end if
    if routineLevel then
	RTN_LEVEL &= id
    end if
    if blockLevel then
	BLK_LEVEL &= id
    end if
end procedure
add_syntax(routine_id("do_return"),0,0,1,1)
add_syntax(routine_id("do_while"),0,1,1,1)
add_syntax(routine_id("do_for"),0,1,1,1)
add_syntax(routine_id("do_if"),0,1,1,1)
add_syntax(routine_id("do_exit"),0,0,0,1)
add_syntax(routine_id("do_assign"),0,1,1,1)
add_syntax(routine_id("do_refop"),0,1,1,1)
add_syntax(routine_id("do_call"),0,1,1,1)
add_syntax(routine_id("do_debug"),0,1,1,1)
add_syntax(routine_id("do_routine"),1,1,0,0)
add_syntax(routine_id("do_constant"),1,1,0,0)
add_syntax(routine_id("do_variable"),1,1,1,0)
add_syntax(routine_id("do_with"),0,1,0,0)
add_syntax(routine_id("do_include"),0,1,0,0)
add_syntax(routine_id("do_global"),0,1,0,0)
global function parse(sequence filename)
    object tokens
    tree_node node
    included = {}
    tokens = tokenize(filename)
    if integer(tokens) then
	return -1
    end if
    node = alloc_node(ROOT_NODE)
    node_set(node,{INCLUDE_FILE,filename})
    parse1(node, tokens, FILE_LEVEL)
    return node
end function

include endext.e
